
% This function is to load two sets of curves
% The original data sets are images and 
% One is MPEG-7 from http://www.dabi.temple.edu/~shape/MPEG7/dataset.html
% other one is FLAVIA from http://flavia.sourceforge.net/
% I use BWBOUNDARIES function in matlab to extract the boundaries and
% generate two files, i.e., CurvesFLAVIA and CurvesMPEG7.
%
% By Wen Huang
    temp1 = load('CurvesFLAVIA');
    temp2 = load('CurvesMPEG7');
    temp3 = load('CurvesHalfFLAVIA');
    temp4 = load('CurvesHalfMPEG7');
    CF = zeros(2, 100, 1907);
    CM = zeros(2, 100, 1400);
    CHF = zeros(2, 100, 946);
    CHM = zeros(2, 100, 700);
    for i = 1 : 1907
        CF(1, :, i) = temp1(:, 2 * i - 1);
        CF(2, :, i) = temp1(:, 2 * i);
    end
    for i = 1 : 1400
        CM(1, :, i) = temp2(:, 2 * i - 1);
        CM(2, :, i) = temp2(:, 2 * i);
    end
    for i = 1 : 946
        CHF(1, :, i) = temp3(:, 2 * i - 1);
        CHF(2, :, i) = temp3(:, 2 * i);
    end
    for i = 1 : 700
        CHM(1, :, i) = temp4(:, 2 * i - 1);
        CHM(2, :, i) = temp4(:, 2 * i);
    end

